OGRE-Next: Ogre::v1::OverlayContainer Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::v1::OverlayContainer Class Reference
Core » Overlays

A 2D element which contains other OverlayElement instances. More...

`#include <OgreOverlayContainer.h>`

Inheritance diagram for Ogre::v1::OverlayContainer:
[legend]

## Public Types
typedef MapIterator< ChildContainerMap > | ChildContainerIterator
typedef map< String, OverlayContainer * >::type | ChildContainerMap
typedef MapIterator< ChildMap > | ChildIterator
typedef map< String, OverlayElement * >::type | ChildMap
Public Types inherited from Ogre::Renderable
typedef map< size_t, Vector4 >::type | CustomParameterMap

## Public Member Functions
| OverlayContainer (const String &name)
| Constructor: do not call direct, use OverlayManager::createOverlayElement.
| ~OverlayContainer () override
void | _addChild (OverlayElement *elem)
void | _notifyParent (OverlayContainer *parent, Overlay *overlay) override
| Overridden from OverlayElement.
void | _notifyViewport () override
| Overridden from OverlayElement.
void | _positionsOutOfDate () override
| Tell the object and its children to recalculate.
void | _removeChild (const String &name)
void | _removeChild (OverlayElement *elem)
void | _update () override
| Overridden from OverlayElement.
void | _updateRenderQueue (RenderQueue *queue, Camera *camera, const Camera *lodCamera) override
| Overridden from OverlayElement.
virtual void | addChild (OverlayElement *elem)
| Adds another OverlayElement to this container.
virtual void | addChildImpl (OverlayContainer *cont)
| Add a nested container to this container.
virtual void | addChildImpl (OverlayElement *elem)
| Adds another OverlayElement to this container.
OverlayElement * | clone (const String &instanceName) override
void | copyFromTemplate (OverlayElement *templateOverlay) override
OverlayElement * | findElementAt (Real x, Real y) override
| This returns a OverlayElement at position x,y.
virtual OverlayElement * | getChild (const String &name)
| Gets the named child of this container.
virtual ChildContainerIterator | getChildContainerIterator ()
| Gets an iterator for just the container children of this object.
virtual ChildIterator | getChildIterator ()
| Gets an object for iterating over all the children of this object.
void | initialise () override
| Initialise gui element.
virtual bool | isChildrenProcessEvents () const
| Should this container pass events to their children.
bool | isContainer () const override
| Overridden from OverlayElement.
virtual void | removeChild (const String &name)
| Removes a named element from this container.
virtual void | setChildrenProcessEvents (bool val)
| Should this container pass events to their children.
Public Member Functions inherited from Ogre::v1::OverlayElement
| OverlayElement (const String &name)
| Constructor: do not call direct, use OverlayManager::createElement.
| ~OverlayElement () override
virtual void | _getClippingRegion (RealRect &clippingRegion)
| Gets the clipping region of the element.
virtual Real | _getDerivedLeft ()
| Gets the 'left' position as derived from own left and that of parents.
virtual Real | _getDerivedTop ()
| Gets the 'top' position as derived from own left and that of parents.
Real | _getHeight () const
| Gets the height of this element in relation to the screen (where 1.0 = screen height).
Real | _getLeft () const
| Gets the left of this element in relation to the screen (where 0 = far left, 1.0 = far right).
virtual Real | _getRelativeHeight ()
| Gets the 'height' as derived from own height and metrics mode.
virtual Real | _getRelativeWidth ()
| Gets the 'width' as derived from own width and metrics mode.
Real | _getTop () const
| Gets the top of this element in relation to the screen (where 0 = far left, 1.0 = far right).
Real | _getWidth () const
| Gets the width of this element in relation to the screen (where 1.0 = screen width).
virtual void | _releaseManualHardwareResources ()
| Notifies that hardware resources were lost.
virtual void | _restoreManualHardwareResources ()
| Notifies that hardware resources should be restored.
void | _setDimensions (Real width, Real height)
| Sets the width and height of this element in relation to the screen (where 1.0 = screen width).
void | _setHeight (Real height)
| Sets the height of this element in relation to the screen (where 1.0 = screen width).
void | _setLeft (Real left)
| Sets the left of this element in relation to the screen (where 1.0 = screen width).
void | _setParent (OverlayContainer *parent)
void | _setPosition (Real left, Real top)
| Sets the left and top of this element in relation to the screen (where 1.0 = screen width).
void | _setTop (Real top)
| Sets the top of this element in relation to the screen (where 1.0 = screen width).
void | _setWidth (Real width)
| Sets the width of this element in relation to the screen (where 1.0 = screen width).
virtual void | _updateFromParent ()
| Updates this elements transform based on it's parent.
virtual bool | contains (Real x, Real y) const
| Returns true if xy is within the constraints of the component.
virtual const DisplayString & | getCaption () const
| Gets the caption for this element.
virtual const ColourValue & | getColour () const
| Gets the colour for this element.
Real | getHeight () const
| Gets the height of this element in relation to the screen (where 1.0 = screen height).
virtual GuiHorizontalAlignment | getHorizontalAlignment () const
| Gets the horizontal alignment for this element.
Real | getLeft () const
| Gets the left of this element in relation to the screen (where 0 = far left, 1.0 = far right).
const LightList & | getLights () const override
| Gets a list of lights, ordered relative to how close they are to this renderable.
const MaterialPtr & | getMaterial () const
| See Renderable.
virtual const String & | getMaterialName () const
| Gets the name of the material this element uses.
virtual GuiMetricsMode | getMetricsMode () const
| Retrieves the current settings of how the element metrics are interpreted.
const String & | getName () const
| Gets the name of this overlay.
OverlayContainer * | getParent ()
| Returns the parent container.
const OverlayElement * | getSourceTemplate () const
| Returns the SourceTemplate for this element.
Real | getTop () const
| Gets the top of this element in relation to the screen (where 0 = top, 1.0 = bottom).
virtual const String & | getTypeName () const =0
| Gets the type name of the element.
virtual GuiVerticalAlignment | getVerticalAlignment () const
| Gets the vertical alignment for this element.
Real | getWidth () const
| Gets the width of this element in relation to the screen (where 1.0 = screen width).
void | getWorldTransforms (Matrix4 *xform) const override
| See Renderable.
virtual void | hide ()
| Hides this element if it was visible.
virtual bool | isCloneable () const
bool | isEnabled () const
virtual bool | isKeyEnabled () const
bool | isVisible () const
| Returns whether or not the element is visible.
virtual void | setCaption (const DisplayString &text)
| Sets the caption on elements that support it.
virtual void | setCloneable (bool c)
virtual void | setColour (const ColourValue &col)
| Sets the colour on elements that support it.
void | setDimensions (Real width, Real height)
| Sets the dimensions of this element in relation to the screen (1.0 = screen width/height).
virtual void | setEnabled (bool b)
void | setHeight (Real height)
| Sets the height of this element in relation to the screen (where 1.0 = screen height).
virtual void | setHorizontalAlignment (GuiHorizontalAlignment gha)
| Sets the horizontal origin for this element.
void | setLeft (Real left)
| Sets the left of this element in relation to the screen (where 0 = far left, 1.0 = far right).
virtual void | setMaterialName (const String &matName)
| Sets the name of the material this element will use.
virtual void | setMetricsMode (GuiMetricsMode gmm)
| Tells this element how to interpret the position and dimension values it is given.
void | setPosition (Real left, Real top)
| Sets the position of the top-left corner of the element, relative to the screen size (1.0 = screen width / height).
void | setTop (Real Top)
| Sets the top of this element in relation to the screen (where 0 = top, 1.0 = bottom).
virtual void | setVerticalAlignment (GuiVerticalAlignment gva)
| Sets the vertical origin for this element.
void | setWidth (Real width)
| Sets the width of this element in relation to the screen (where 1.0 = screen width).
virtual void | show ()
| Shows this element if it was hidden.
Public Member Functions inherited from Ogre::StringInterface
| StringInterface ()
virtual | ~StringInterface ()
| Virtual destructor, see Effective C++.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
ParamDictionary * | getParamDictionary ()
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary () const
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
const ParameterList & | getParameters () const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.
Public Member Functions inherited from Ogre::Renderable
| Renderable ()
virtual | ~Renderable ()
| Virtual destructor needed as class has virtual methods.
virtual void | _setHlmsHashes (uint32 hash, uint32 casterHash)
| Manually sets the hlms hashes. Don't call this directly.
virtual void | _setNullDatablock ()
| Sets the datablock to a null pointer.
virtual void | _updateCustomGpuParameter (const GpuProgramParameters_AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
void | addPoseWeight (size_t index, float w)
virtual bool | getCastsShadows () const
| Method which reports whether this renderable would normally cast a shadow.
uint8 | getCurrentMaterialLod () const
const Vector4 & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
const CustomParameterMap & | getCustomParameters () const
HlmsDatablock * | getDatablock () const
const String & | getDatablockOrMaterialName () const
uint32 | getHlmsCasterHash () const
uint32 | getHlmsHash () const
MaterialPtr | getMaterial () const
| Retrieves the material this renderable object uses.
unsigned short | getNumPoses () const
virtual unsigned short | getNumWorldTransforms () const
| Returns the number of world transform matrices this renderable requires.
virtual bool | getPolygonModeOverrideable () const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
bool | getPoseHalfPrecision () const
bool | getPoseNormals () const
TexBufferPacked * | getPoseTexBuffer () const
float | getPoseWeight (size_t index) const
float * | getPoseWeights () const
virtual void | getRenderOperation (v1::RenderOperation &op, bool casterPass)=0
| Gets the render operation required to send this object to the frame buffer.
uint8 | getRenderQueueSubGroup () const
bool | getUseIdentityProjection () const
| Returns whether or not to use an 'identity' projection.
bool | getUseIdentityView () const
| Returns whether or not to use an 'identity' view.
virtual bool | getUseIdentityViewProjMatrixIsDynamic () const
| Returns whether the Hlms implementation should evaluate getUseIdentityProjection per object at runtime, or if it can assume the Renderable will remain with the same setting until the datablock is flushed (performance optimization).
virtual bool | getUseIdentityWorldMatrix () const
| Returns whether the world matrix is an identity matrix.
virtual OGRE_DEPRECATED const Any & | getUserAny () const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class.
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class.
const VertexArrayObjectArray & | getVaos (VertexPass vertexPass) const
bool | hasCustomParameter (size_t index) const
| Checks whether a custom value is associated with this Renderable at the given index.
bool | hasSkeletonAnimation () const
virtual void | postRender (SceneManager *sm, RenderSystem *rsys)
| Called immediately after the Renderable has been rendered.
virtual bool | preRender (SceneManager *sm, RenderSystem *rsys)
| Called just prior to the Renderable being rendered.
void | removeCustomParameter (size_t index)
| Removes a custom value which is associated with this Renderable at the given index.
void | setCustomParameter (size_t index, const Vector4 &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
virtual void | setDatablock (HlmsDatablock *datablock)
| Assigns a datablock (i.e. HLMS Material) to this renderable.
void | setDatablock (IdString datablockName)
| Assigns a datablock (i.e.
void | setDatablockOrMaterialName (String materialName, String groupName)
| First tries to see if an HLMS datablock exist with the given name, if not, tries to search among low level materials.
virtual void | setMaterial (const MaterialPtr &material)
| Sets the given material. Overrides HLMS materials.
void | setMaterialName (const String &name, const String &groupName)
| Sets the name of the Material to be used. Prefer using HLMS.
virtual void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
void | setPoseWeight (size_t index, float w)
void | setRenderQueueSubGroup (uint8 subGroup)
| Sets the render queue sub group.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
virtual OGRE_DEPRECATED void | setUserAny (const Any &anything)

## Additional Inherited Members
Static Public Member Functions inherited from Ogre::StringInterface
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.
Static Public Member Functions inherited from Ogre::Renderable
static uint8 | getDefaultRenderQueueSubGroup ()
static void | setDefaultRenderQueueSubGroup (uint8 subGroup)
| Sets the default render queue sub group for all future Renderable instances.
Public Attributes inherited from Ogre::Renderable
uint8 | mCustomParameter
uint32 | mHlmsGlobalIndex
| Index in the vector holding this Rendrable reference in the HLMS datablock.
bool | mRenderableVisible
| Control visibility at Renderable (e.g.

## Detailed Description

A 2D element which contains other OverlayElement instances.

Remarks
  This is a specialisation of OverlayElement for 2D elements that contain other elements. These are also the smallest elements that can be attached directly to an Overlay.
  OverlayContainers should be managed using OverlayManager. This class is responsible for instantiating / deleting elements, and also for accepting new types of element from plugins etc.

## Member Typedef Documentation

## ◆ ChildContainerIterator

typedef MapIterator<ChildContainerMap> Ogre::v1::OverlayContainer::ChildContainerIterator

## ◆ ChildContainerMap

typedef map<String,OverlayContainer*>::type Ogre::v1::OverlayContainer::ChildContainerMap

## ◆ ChildIterator

typedef MapIterator<ChildMap> Ogre::v1::OverlayContainer::ChildIterator

## ◆ ChildMap

typedef map<String,OverlayElement*>::type Ogre::v1::OverlayContainer::ChildMap

## Constructor & Destructor Documentation

## ◆ OverlayContainer()

Ogre::v1::OverlayContainer::OverlayContainer | ( | const String & | name | ) |

Constructor: do not call direct, use OverlayManager::createOverlayElement.

Referenced by _notifyParent(), and addChildImpl().

## ◆ ~OverlayContainer()

Ogre::v1::OverlayContainer::~OverlayContainer | ( |  | ) |
| override

## Member Function Documentation

## ◆ _addChild()

void Ogre::v1::OverlayContainer::_addChild | ( | OverlayElement * | elem | ) |

References Ogre::v1::OverlayElement::OverlayElement().

## ◆ _notifyParent()

void Ogre::v1::OverlayContainer::_notifyParent | ( | OverlayContainer * | parent,
|  | Overlay * | overlay )
| overridevirtual

Overridden from OverlayElement.

Reimplemented from Ogre::v1::OverlayElement.

References OverlayContainer().

## ◆ _notifyViewport()

void Ogre::v1::OverlayContainer::_notifyViewport | ( |  | ) |
| overridevirtual

Overridden from OverlayElement.

Reimplemented from Ogre::v1::OverlayElement.

## ◆ _positionsOutOfDate()

void Ogre::v1::OverlayContainer::_positionsOutOfDate | ( |  | ) |
| overridevirtual

Tell the object and its children to recalculate.

Reimplemented from Ogre::v1::OverlayElement.

## ◆ _removeChild() [1/2]

void Ogre::v1::OverlayContainer::_removeChild | ( | const String & | name | ) |

## ◆ _removeChild() [2/2]

void Ogre::v1::OverlayContainer::_removeChild | ( | OverlayElement * | elem | ) |
| inline

References Ogre::v1::OverlayElement::OverlayElement(), _removeChild(), and Ogre::v1::OverlayElement::getName().

Referenced by _removeChild().

## ◆ _update()

void Ogre::v1::OverlayContainer::_update | ( |  | ) |
| overridevirtual

Overridden from OverlayElement.

Reimplemented from Ogre::v1::OverlayElement.

## ◆ _updateRenderQueue()

void Ogre::v1::OverlayContainer::_updateRenderQueue | ( | RenderQueue * | queue,
|  | Camera * | camera,
|  | const Camera * | lodCamera )
| overridevirtual

Overridden from OverlayElement.

Reimplemented from Ogre::v1::OverlayElement.

Reimplemented in Ogre::v1::PanelOverlayElement.

## ◆ addChild()

virtual void Ogre::v1::OverlayContainer::addChild | ( | OverlayElement * | elem | ) |
| virtual

Adds another OverlayElement to this container.

References Ogre::v1::OverlayElement::OverlayElement().

## ◆ addChildImpl() [1/2]

virtual void Ogre::v1::OverlayContainer::addChildImpl | ( | OverlayContainer * | cont | ) |
| virtual

Add a nested container to this container.

References OverlayContainer().

## ◆ addChildImpl() [2/2]

virtual void Ogre::v1::OverlayContainer::addChildImpl | ( | OverlayElement * | elem | ) |
| virtual

Adds another OverlayElement to this container.

References Ogre::v1::OverlayElement::OverlayElement().

## ◆ clone()

OverlayElement * Ogre::v1::OverlayContainer::clone | ( | const String & | instanceName | ) |
| overridevirtual

Reimplemented from Ogre::v1::OverlayElement.

References Ogre::v1::OverlayElement::OverlayElement().

## ◆ copyFromTemplate()

void Ogre::v1::OverlayContainer::copyFromTemplate | ( | OverlayElement * | templateOverlay | ) |
| overridevirtual

Reimplemented from Ogre::v1::OverlayElement.

References Ogre::v1::OverlayElement::OverlayElement().

## ◆ findElementAt()

OverlayElement * Ogre::v1::OverlayContainer::findElementAt | ( | Real | x,
|  | Real | y )
| overridevirtual

This returns a OverlayElement at position x,y.

Reimplemented from Ogre::v1::OverlayElement.

References Ogre::v1::OverlayElement::OverlayElement().

## ◆ getChild()

virtual OverlayElement * Ogre::v1::OverlayContainer::getChild | ( | const String & | name | ) |
| virtual

Gets the named child of this container.

References Ogre::v1::OverlayElement::OverlayElement().

## ◆ getChildContainerIterator()

virtual ChildContainerIterator Ogre::v1::OverlayContainer::getChildContainerIterator | ( |  | ) |
| virtual

Gets an iterator for just the container children of this object.

Remarks
  Good for cascading updates without having to use RTTI

## ◆ getChildIterator()

virtual ChildIterator Ogre::v1::OverlayContainer::getChildIterator | ( |  | ) |
| virtual

Gets an object for iterating over all the children of this object.

## ◆ initialise()

void Ogre::v1::OverlayContainer::initialise | ( |  | ) |
| overridevirtual

Initialise gui element.

Implements Ogre::v1::OverlayElement.

Reimplemented in Ogre::v1::PanelOverlayElement.

## ◆ isChildrenProcessEvents()

virtual bool Ogre::v1::OverlayContainer::isChildrenProcessEvents | ( |  | ) | const
| inlinevirtual

Should this container pass events to their children.

## ◆ isContainer()

bool Ogre::v1::OverlayContainer::isContainer | ( |  | ) | const
| inlineoverridevirtual

Overridden from OverlayElement.

Reimplemented from Ogre::v1::OverlayElement.

## ◆ removeChild()

virtual void Ogre::v1::OverlayContainer::removeChild | ( | const String & | name | ) |
| virtual

Removes a named element from this container.

## ◆ setChildrenProcessEvents()

virtual void Ogre::v1::OverlayContainer::setChildrenProcessEvents | ( | bool | val | ) |
| inlinevirtual

Should this container pass events to their children.

The documentation for this class was generated from the following file:

- OgreOverlayContainer.h